#Использовать annotations
#Использовать reflector

// КонтейнерАннотаций
//
Перем _КонтейнерАннотаций;

// ОпределениеАннотации - определение аннотации &Реализует.
//
Перем _ОпределениеАннотацииРеализует;

// ОпределениеАннотации - определение аннотации &Расширяет.
//
Перем _ОпределениеАннотацииРасширяет;

// ОпределениеАннотации - определение аннотации &Интерфейс.
//
Перем _ОпределениеАннотацииИнтерфейс;

// Проверить, что объект реализует все интерфейсы, указанные в аннотации &Реализует.
// Если объект не реализует какой-либо из интерфейсов, будет вызвано исключение.
//
// Параметры:
// ПроверяемыйОбъект - Сценарий, Тип - объект, реализующий интерфейсы.
//
Процедура ИнтерфейсыРеализованыКорректно(ПроверяемыйОбъект) Экспорт
	
	РефлекторОбъекта = Новый РефлекторОбъекта(ПроверяемыйОбъект);
	МетодыСАннотацией = РефлекторОбъекта.ПолучитьТаблицуМетодов("Реализует", Ложь);
	
	Если МетодыСАннотацией.Количество() = 0 Тогда
		Возврат;
	КонецЕсли;

	ПосещенныеИнтерфейсы = Новый Соответствие;

	Для Каждого Метод Из МетодыСАннотацией Цикл
		
		Аннотации = РаботаСАннотациями.НайтиАннотации(Метод.Аннотации, "Реализует");
		
		Для Каждого Аннотация Из Аннотации Цикл
			_ОпределениеАннотацииРеализует.Проверить(Аннотация, Строка(ПроверяемыйОбъект));
			ОбъектАннотации = _ОпределениеАннотацииРеализует.СоздатьОбъектАннотации(Аннотация);
			ИмяИнтерфейса = ОбъектАннотации.ИмяИнтерфейса();
			
			ПроверитьИнтерфейсИмеетАннотациюИнтерфейс(ИмяИнтерфейса);
			ПроверитьРеализациюИнтерфейсаРекурсивно(РефлекторОбъекта, ИмяИнтерфейса, ПосещенныеИнтерфейсы);
		КонецЦикла;
	
	КонецЦикла;
КонецПроцедуры

// Проверить реализацию интерфейса с учетом наследования интерфейсов
//
// Параметры:
//  РефлекторОбъекта - РефлекторОбъекта - рефлектор проверяемого объекта
//  ИмяИнтерфейса - Строка - имя проверяемого интерфейса
//  ПосещенныеИнтерфейсы - Соответствие - коллекция уже проверенных интерфейсов
//                                    для предотвращения циклических зависимостей
//
Процедура ПроверитьРеализациюИнтерфейсаРекурсивно(РефлекторОбъекта, ИмяИнтерфейса, ПосещенныеИнтерфейсы)
	
	// Проверяем, не был ли этот интерфейс уже проверен (защита от циклических зависимостей)
	Если ПосещенныеИнтерфейсы.Получить(ИмяИнтерфейса) <> Неопределено Тогда
		Возврат;
	КонецЕсли;
	
	// Отмечаем интерфейс как посещенный
	ПосещенныеИнтерфейсы.Вставить(ИмяИнтерфейса, Истина);
	
	// Проверяем реализацию самого интерфейса
	ИнтерфейсОбъекта = Новый ИнтерфейсОбъекта();
	ИнтерфейсОбъекта.ИзОбъекта(Тип(ИмяИнтерфейса));
	
	ВызватьИсключениеРеализации = Истина;
	РефлекторОбъекта.РеализуетИнтерфейс(ИнтерфейсОбъекта, ВызватьИсключениеРеализации);
	
	// Проверяем реализацию наследуемых интерфейсов
	РефлекторИнтерфейса = Новый РефлекторОбъекта(Тип(ИмяИнтерфейса));
	
	// Сначала проверяем аннотацию &Расширяет для наследования интерфейсов
	МетодыИнтерфейсаСАннотациейРасширяет = РефлекторИнтерфейса.ПолучитьТаблицуМетодов("Расширяет", Ложь);
	
	Для Каждого МетодИнтерфейса Из МетодыИнтерфейсаСАннотациейРасширяет Цикл
		
		АннотацииИнтерфейса = РаботаСАннотациями.НайтиАннотации(МетодИнтерфейса.Аннотации, "Расширяет");
		
		Для Каждого АннотацияИнтерфейса Из АннотацииИнтерфейса Цикл
			_ОпределениеАннотацииРасширяет.Проверить(АннотацияИнтерфейса, ИмяИнтерфейса);
			ОбъектАннотацииИнтерфейса = _ОпределениеАннотацииРасширяет.СоздатьОбъектАннотации(АннотацияИнтерфейса);
			ИмяНаследуемогоИнтерфейса = ОбъектАннотацииИнтерфейса.ИмяТипаРодителя();
			
			// Рекурсивно проверяем наследуемый интерфейс
			ПроверитьИнтерфейсИмеетАннотациюИнтерфейс(ИмяНаследуемогоИнтерфейса);
			ПроверитьРеализациюИнтерфейсаРекурсивно(РефлекторОбъекта, ИмяНаследуемогоИнтерфейса, ПосещенныеИнтерфейсы);
		КонецЦикла;
		
	КонецЦикла;
	
КонецПроцедуры

// Проверить, что интерфейс имеет аннотацию &Интерфейс
//
// Параметры:
//  ИмяИнтерфейса - Строка - имя проверяемого интерфейса
//
Процедура ПроверитьИнтерфейсИмеетАннотациюИнтерфейс(ИмяИнтерфейса)
	
	Попытка
		ТипИнтерфейса = Тип(ИмяИнтерфейса);
	Исключение
		ВызватьИсключение СтрШаблон("Не удалось найти интерфейс '%1': %2", ИмяИнтерфейса, ОписаниеОшибки());
	КонецПопытки;
	
	РефлекторИнтерфейса = Новый РефлекторОбъекта(ТипИнтерфейса);
	
	// Проверяем аннотацию &Интерфейс на конструкторе
	МетодыСАннотацией = РефлекторИнтерфейса.ПолучитьТаблицуМетодов("Интерфейс", Ложь);
	
	Если МетодыСАннотацией.Количество() = 0 Тогда
		ВызватьИсключение СтрШаблон("Интерфейс '%1' должен иметь аннотацию &Интерфейс", ИмяИнтерфейса);
	КонецЕсли;
	
	// Создаем объект аннотации и проверяем корректность
	Для Каждого МетодСАннотацией Из МетодыСАннотацией Цикл
		АннотацииИнтерфейса = РаботаСАннотациями.НайтиАннотации(МетодСАннотацией.Аннотации, "Интерфейс");
		Для Каждого АннотацияИнтерфейса Из АннотацииИнтерфейса Цикл
			_ОпределениеАннотацииИнтерфейс.Проверить(АннотацияИнтерфейса, ИмяИнтерфейса);
		КонецЦикла;
	КонецЦикла;
	
КонецПроцедуры

// Класс для проверки корректности реализации интерфейсов объектом
//
// Параметры:
//  КонтейнерАннотаций - КонтейнерАннотаций - задаваемый из-вне контейнер аннотаций.
//                                            Позволяет использовать общий контейнер аннотаций для всего приложения.
Процедура ПриСозданииОбъекта(КонтейнерАннотаций = Неопределено)
	Если КонтейнерАннотаций = Неопределено Тогда
		_КонтейнерАннотаций = Новый КонтейнерАннотаций();
		_КонтейнерАннотаций.ДобавитьАннотацию(Тип("АннотацияРеализует"));
		_КонтейнерАннотаций.ДобавитьАннотацию(Тип("АннотацияИнтерфейс"));
		_КонтейнерАннотаций.ДобавитьАннотацию(Тип("АннотацияРасширяет"));
	Иначе
		_КонтейнерАннотаций = КонтейнерАннотаций;
	КонецЕсли;

	_ОпределениеАннотацииРеализует = _КонтейнерАннотаций.ПолучитьОпределениеАннотации("Реализует");
	_ОпределениеАннотацииРасширяет = _КонтейнерАннотаций.ПолучитьОпределениеАннотации("Расширяет");
	_ОпределениеАннотацииИнтерфейс = _КонтейнерАннотаций.ПолучитьОпределениеАннотации("Интерфейс");

КонецПроцедуры