#Использовать annotations
#Использовать decorator
#Использовать reflector

// КонтейнерАннотаций
//
Перем _КонтейнерАннотаций;

// Сценарий
//
Перем _ОбъектНаследник;

// Сценарий
//
Перем _ОбъектРодитель;

// ТаблицаЗначений
//
Перем _МетодыНаследника;

// СтрокаТаблицыЗначений
//
Перем _КонструкторНаследника;

// РефлекторОбъекта
//
Перем _РефлекторОбъекта;

// Выполняет связывание объекта-наследника с объектом-родителем и возвращает ПостроительДекоратора,
// который содержит методы и поля объекта-наследника и методы объекта-родителя.
//
// Поле объекта-наследника, помеченное аннотаций &Родитель, будет заполнено объектом-родителем.
// Если аннотация не найдена, будет для хранения родителя будет создано поле с именем "_ОбъектРодитель".
//
// Объект-наследник может содержать методы, совпадающие по именам с методами объекта-родителя. При необходимости
// метод объекта-наследника может вызывать метод объекта-родителя через поле-родитель.
// 
// Объект-наследник должен иметь аннотацию &Расширяет, в которой указано имя типа объекта-родителя.
//
// Возвращаемое значение:
//  ПостроительДекоратора - полностью сконфигурированный построитель декоратора, из которого можно получить
//                          итоговый класс-наследник.
//
Функция СоздатьДекоратор() Экспорт

	ИмяАннотацииРасширяет = "Расширяет";

	ИнициализироватьКонтейнерАннотаций();
	
	МетодыНаследника = ПолучитьМетодыНаследника();
	КонструкторНаследника = ПолучитьКонструкторНаследника(МетодыНаследника);
	
	ДанныеРодителя = ПолучитьДанныеРодителя(КонструкторНаследника, ИмяАннотацииРасширяет);
	
	Декоратор = Новый ПостроительДекоратора(_ОбъектНаследник);

	НастроитьПолеРодителя(Декоратор);
	СоздатьПроксиМетодыРодителя(Декоратор, ДанныеРодителя.МетодыРодителя);
	СоздатьКонструктор(Декоратор, КонструкторНаследника, ДанныеРодителя.МетодыРодителя, ИмяАннотацииРасширяет);
	СоздатьМетодПредставления(Декоратор, ДанныеРодителя.ИмяТипаРодителя);

	Возврат Декоратор;

КонецФункции

Процедура ИнициализироватьКонтейнерАннотаций()
	Если _КонтейнерАннотаций = Неопределено Тогда
		_КонтейнерАннотаций = Новый КонтейнерАннотаций();
		_КонтейнерАннотаций.ДобавитьАннотацию(Тип("АннотацияРасширяет"));
	КонецЕсли;
КонецПроцедуры

Функция ПолучитьМетодыНаследника()
	Если _МетодыНаследника = Неопределено Тогда
		Возврат _РефлекторОбъекта.ПолучитьТаблицуМетодов(Неопределено, Ложь);
	Иначе
		Возврат _МетодыНаследника;
	КонецЕсли;
КонецФункции

Функция ПолучитьКонструкторНаследника(МетодыНаследника)
	ИменаПолейКонструктора = "Имя";
	Если _КонструкторНаследника = Неопределено Тогда
		// Ищем реальный конструктор (ПриСозданииОбъекта или OnObjectCreate)
		КонструкторНаследника = МетодыНаследника.Найти("ПриСозданииОбъекта", ИменаПолейКонструктора);
		Если КонструкторНаследника = Неопределено Тогда
			КонструкторНаследника = МетодыНаследника.Найти("OnObjectCreate", ИменаПолейКонструктора);
		КонецЕсли;
		
		// У наследника обязан быть конструктор с аннотацией &Расширяет
		Если КонструкторНаследника = Неопределено Тогда
			ВызватьИсключение("У наследника обязан быть конструктор с аннотацией &Расширяет");
		КонецЕсли;
		
		Возврат КонструкторНаследника;
	Иначе
		Возврат _КонструкторНаследника;
	КонецЕсли;
КонецФункции

Функция ПолучитьДанныеРодителя(КонструкторНаследника, ИмяАннотацииРасширяет)
	ОпределениеАннотацииРасширяет = _КонтейнерАннотаций.ПолучитьОпределениеАннотации(ИмяАннотацииРасширяет);
	АннотацияРасширяет = РаботаСАннотациями.НайтиАннотацию(КонструкторНаследника.Аннотации, 
		ИмяАннотацииРасширяет);
	
	ОбъектАннотацииРасширяет = ОпределениеАннотацииРасширяет.СоздатьОбъектАннотации(АннотацияРасширяет);

	ИмяТипаРодителя = ОбъектАннотацииРасширяет.ИмяТипаРодителя();
	РефлекторОбъектаРодителя = Новый РефлекторОбъекта(Тип(ИмяТипаРодителя));
	МетодыРодителя = РефлекторОбъектаРодителя.ПолучитьТаблицуМетодов(Неопределено, Ложь);
	
	Результат = Новый Структура;
	Результат.Вставить("ИмяТипаРодителя", ИмяТипаРодителя);
	Результат.Вставить("МетодыРодителя", МетодыРодителя);
	
	Возврат Результат;
КонецФункции

Процедура НастроитьПолеРодителя(Декоратор)
	ИмяПоляОбъектРодитель = ИмяПоляОбъектРодитель();
	Если _РефлекторОбъекта.ЕстьСвойство(ИмяПоляОбъектРодитель) Тогда
		Рефлектор = Новый Рефлектор();
		Рефлектор.УстановитьСвойство(_ОбъектНаследник, ИмяПоляОбъектРодитель, _ОбъектРодитель);
	Иначе
		Поле = Новый Поле(ИмяПоляОбъектРодитель)
			.ЗначениеПоУмолчанию(_ОбъектРодитель);
		Декоратор.Поле(Поле);
	КонецЕсли;
КонецПроцедуры

Процедура СоздатьПроксиМетодыРодителя(Декоратор, МетодыРодителя)
	ИмяПоляОбъектРодитель = ИмяПоляОбъектРодитель();
	
	Для Каждого МетодРодителя Из МетодыРодителя Цикл
		
		Если НЕ МетодРодителя.Экспорт Тогда
			Продолжить;
		КонецЕсли;

		// Проверяем, есть ли уже такой метод в наследнике
		Если МетодУжеОпределенВНаследнике(МетодРодителя) Тогда
			// Метод уже определен в наследнике, пропускаем создание прокси
			Продолжить;
		КонецЕсли;

		Метод = Новый Метод(МетодРодителя.Имя).Публичный();

		ПеренестиАннотации(Метод, МетодРодителя.Аннотации);
		
		ИменаПараметров = Новый Массив;
		Для Каждого ПараметрРодителя Из МетодРодителя.Параметры Цикл
			ПараметрМетода = ПараметрМетодаИзДанныхРефлектора(ПараметрРодителя);
			Метод.Параметр(ПараметрМетода);

			ИменаПараметров.Добавить(ПараметрРодителя.Имя);
		КонецЦикла;
		СтрокаПараметры = СтрСоединить(ИменаПараметров, ", ");
		
		ТелоМетода = ИмяПоляОбъектРодитель + "." + МетодРодителя.Имя + "(" + СтрокаПараметры + ");";
		Если МетодРодителя.ЭтоФункция Тогда
			ТелоМетода = "Возврат " + ТелоМетода;
		Иначе
			Метод.ЭтоПроцедура();
		КонецЕсли;
		Метод.ТелоМетода(ТелоМетода);

		Декоратор.Метод(Метод);

	КонецЦикла;
КонецПроцедуры

Функция МетодУжеОпределенВНаследнике(МетодРодителя)
	МетодИмя = МетодРодителя.Имя;
	КоличествоПараметров = МетодРодителя.КоличествоПараметров;
	
	ЭтоФункцияВНаследнике = МетодРодителя.ЭтоФункция 
		И _РефлекторОбъекта.ЕстьФункция(МетодИмя, КоличествоПараметров);
	ЭтоПроцедураВНаследнике = НЕ МетодРодителя.ЭтоФункция 
		И _РефлекторОбъекта.ЕстьПроцедура(МетодИмя, КоличествоПараметров);
	
	Возврат ЭтоФункцияВНаследнике ИЛИ ЭтоПроцедураВНаследнике;
КонецФункции

Процедура СоздатьКонструктор(Декоратор, КонструкторНаследника, МетодыРодителя, ИмяАннотацииРасширяет)
	ИменаПолейКонструктора = "Имя";
	// Перенос конструктора  
	КонструкторРодителя = МетодыРодителя.Найти("ПриСозданииОбъекта", ИменаПолейКонструктора);
	Если КонструкторРодителя = Неопределено Тогда
		КонструкторРодителя = МетодыРодителя.Найти("OnObjectCreate", ИменаПолейКонструктора);
	КонецЕсли;

	// Конструктор в наследнике всегда обязан быть
	Метод = Новый Метод(КонструкторНаследника.Имя).ЭтоПроцедура();
	
	ПеренестиАннотации(Метод, КонструкторНаследника.Аннотации, ИмяАннотацииРасширяет);
	
	Если КонструкторРодителя <> Неопределено Тогда
		ПеренестиАннотации(Метод, КонструкторРодителя.Аннотации, ИмяАннотацииРасширяет);
	КонецЕсли;

	Декоратор.Метод(Метод);
КонецПроцедуры

Процедура СоздатьМетодПредставления(Декоратор, ИмяТипаРодителя)
	КоличествоПараметровПредставления = 2;
	ПредставлениеТипа = "" + ТипЗнч(_ОбъектНаследник) + "_Расширяет_" + ИмяТипаРодителя;
	
	// Проверим, есть ли уже метод ОбработкаПолученияПредставления в наследнике
	ЕстьОбработкаПредставления = _РефлекторОбъекта.ЕстьПроцедура("ОбработкаПолученияПредставления", 
		КоличествоПараметровПредставления)
		ИЛИ _РефлекторОбъекта.ЕстьПроцедура("OnGettingPresentation", 
		КоличествоПараметровПредставления);
	
	Если НЕ ЕстьОбработкаПредставления Тогда
		Метод = Новый Метод("ОбработкаПолученияПредставления")
			.ЭтоПроцедура()
			.Параметр(Новый ПараметрМетода("Представление"))
			.Параметр(Новый ПараметрМетода("СтандартнаяОбработка"))
			.ТелоМетода("СтандартнаяОбработка = Ложь; Представление = """ + ПредставлениеТипа + """;");
		Декоратор.Метод(Метод);
	КонецЕсли;
КонецПроцедуры

// Получить имя поля, в котором хранится объект-родитель.
// Возвращается имя поля, помеченное аннотацией &Родитель, или "_ОбъектРодитель", если аннотация не найдена.
//
// Возвращаемое значение:
//   Строка
//
Функция ИмяПоляОбъектРодитель() Экспорт

	СвойстваНаследника_Родитель = _РефлекторОбъекта.ПолучитьТаблицуСвойств("Родитель", Истина);
	Если СвойстваНаследника_Родитель.Количество() = 0 Тогда
		Возврат "_ОбъектРодитель";
	Иначе
		Возврат СвойстваНаследника_Родитель[0].Имя;
	КонецЕсли;

КонецФункции

// Выполнить связывание объекта-наследника с объектом-родителем и вернуть результирующий класс
// с общим интерфейсом.
// См. СоздатьДекоратор()
//
// Возвращаемое значение:
//  Сценарий - класс-наследник с общим интерфейсом
//
Функция Построить() Экспорт

	Возврат СоздатьДекоратор().Построить();

КонецФункции

// Сеттер для контейнера аннотаций.
// Позволяет использовать общий контейнер аннотаций для всего приложения.
//
// Параметры:
//  КонтейнерАннотаций - КонтейнерАннотаций - устанавливаемый контейнер аннотаций.
//
Процедура УстановитьКонтейнерАннотаций(КонтейнерАннотаций) Экспорт
	_КонтейнерАннотаций = КонтейнерАннотаций;
КонецПроцедуры

Процедура ПеренестиАннотации(МетодИлиПараметр, Аннотации, ИмяИсключаемойАннотации = "")
	Для Каждого ДанныеАннотации Из Аннотации Цикл
		Если ВРег(ДанныеАннотации.Имя) = ВРег(ИмяИсключаемойАннотации) Тогда
			Продолжить;
		КонецЕсли;

		Аннотация = АннотацияИзДанныхРефлектора(ДанныеАннотации);
		МетодИлиПараметр.Аннотация(Аннотация);
	КонецЦикла;
КонецПроцедуры

Функция ПараметрМетодаИзДанныхРефлектора(Параметр)

	ПараметрМетода = Новый ПараметрМетода(Параметр.Имя);
	Если Параметр.ПоЗначению Тогда
		ПараметрМетода.ПоЗначению();
	КонецЕсли;
	Если Параметр.ЕстьЗначениеПоУмолчанию Тогда
		ПараметрМетода.ЗначениеПоУмолчанию(Параметр.ЗначениеПоУмолчанию);
	КонецЕсли;

	ПеренестиАннотации(ПараметрМетода, Параметр.Аннотации);

	Возврат ПараметрМетода;

КонецФункции

Функция АннотацияИзДанныхРефлектора(ДанныеАннотации)
	
	Аннотация = Новый Аннотация(ДанныеАннотации.Имя);
	Для Каждого Параметр Из ДанныеАннотации.Параметры Цикл
		Аннотация.Параметр(Параметр.Значение, Параметр.Имя);
	КонецЦикла;

	Возврат Аннотация;

КонецФункции

// Класс, выполняющий связывание объекта-наследника с объектом-родителем и создающий класс-обертку (декоратор)
// с общим интерфейсом.
//
// Параметры:
//  ОбъектНаследник - Сценарий - объект-наследник. Должен содержать аннотацию &Расширяет.
//  ОбъектРодитель - Сценарий - объект-родитель.
//  МетодыНаследника - ТаблицаЗначений - методы объекта-наследника, как они возвращаются рефлектором.
//                                       Может использоваться для сокращения использования рефлектора или
//                                       необходимости дополнительной обработки методов, например, разворачивания
//                                       аннотаций библиотекой annotations.
//  КонструкторНаследника - СтрокаТаблицыЗначений - данные о конструкторе объекта-наследника,
//                                                  как они возвращаются рефлектором.
Процедура ПриСозданииОбъекта(
	ОбъектНаследник,
	ОбъектРодитель,
	МетодыНаследника = Неопределено,
	КонструкторНаследника = Неопределено
)
	_ОбъектНаследник = ОбъектНаследник;
	_ОбъектРодитель = ОбъектРодитель;
	_МетодыНаследника = МетодыНаследника;
	_КонструкторНаследника = КонструкторНаследника;

	_РефлекторОбъекта = Новый РефлекторОбъекта(_ОбъектНаследник);
КонецПроцедуры
